
Blockly.BlockSvg.START_HAT = true;

Blockly.Blocks['sleep'] = {
init: function() {
    this.appendDummyInput()
    .appendField(Blockly.Msg.Wait)
    .appendField(new Blockly.FieldNumber(0, 0), "time")
    .appendField(Blockly.Msg.Sleep_Unit);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#fbb13b");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

Blockly.Blocks['ultrasound'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/超声波.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Ultrasound);
    this.setOutput(true, "Number");
    this.setColour("#5ca3fb");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

Blockly.Blocks['motoraction'] = {
init: function() {
    this.appendValueInput("speed")
    .setCheck("Number")
    .appendField(new Blockly.FieldImage("../image/img/扩展电机.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Motor)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.Port + "1","PORT1"], [Blockly.Msg.Port + "2","PORT2"], [Blockly.Msg.Port + "3","PORT3"]]), "port")
    .appendField(Blockly.Msg.Direction)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.Clockwise,"CLOCKWISE"], [Blockly.Msg.Anticlockwise,"ANTICLOCKWISE"]]), "direction")
    .appendField(Blockly.Msg.Speed_Range);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#00ceb8");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

Blockly.Blocks['motorstop'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/扩展电机停止.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Motor_Stop)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.All,"ALL"], [Blockly.Msg.Port + "1","PORT1"], [Blockly.Msg.Port + "2","PORT2"], [Blockly.Msg.Port + "3","PORT3"]]), "port");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#00ceb8");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

Blockly.Blocks['gyro'] = {
init: function() {
    this.appendDummyInput()
    .appendField(Blockly.Msg.Gyroscope)
    .appendField(new Blockly.FieldDropdown([["x","OPTION_X"], ["y","OPTION_Y"]]), "GYRO_XY");
    this.setOutput(true, "Number");
    this.setColour("#5ca3fb");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

// 音效
Blockly.Blocks['sound'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../icon/Sound.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Sound)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.Sound + "1","SOUND_1"], [Blockly.Msg.Sound + "2","SOUND_2"], [Blockly.Msg.Sound + "3","SOUND_3"], [Blockly.Msg.Sound + "4","SOUND_4"], [Blockly.Msg.Sound + "5","SOUND_5"], [Blockly.Msg.Sound + "6","SOUND_6"], [Blockly.Msg.Sound + "7","SOUND_7"], [Blockly.Msg.Sound + "8","SOUND_8"], [Blockly.Msg.Sound + "9","SOUND_9"], [Blockly.Msg.Sound + "10","SOUND_10"], [Blockly.Msg.Sound + "11","SOUND_11"]]), "sound");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

// 背景音乐
Blockly.Blocks['bgmusic'] = {
init: function() {
    this.appendDummyInput()
    .appendField(Blockly.Msg.BGMusic)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.Music + "1","BGM_1"], [Blockly.Msg.Music + "2","BGM_2"], [Blockly.Msg.Music + "3","BGM_3"], [Blockly.Msg.Music + "4","BGM_4"], [Blockly.Msg.Music + "5","BGM_5"], [Blockly.Msg.Music + "6","BGM_6"], [Blockly.Msg.Music + "7","BGM_7"], [Blockly.Msg.Music + "8","BGM_8"]]), "bgMusic");
    this.appendStatementInput("statements")
    .setCheck(null)
    .appendField(new Blockly.FieldImage("../image/img/音乐.png", 15, 15, "*"));
    this.setPreviousStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

// 播放音乐
Blockly.Blocks['bgstart'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/音乐.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Play)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.Music + "1","BGM_1"], [Blockly.Msg.Music + "2","BGM_2"], [Blockly.Msg.Music + "3","BGM_3"], [Blockly.Msg.Music + "4","BGM_4"], [Blockly.Msg.Music + "5","BGM_5"], [Blockly.Msg.Music + "6","BGM_6"], [Blockly.Msg.Music + "7","BGM_7"], [Blockly.Msg.Music + "8","BGM_8"]]), "bgMusic");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

// 停止播放音乐
Blockly.Blocks['bgend'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/音乐.png", 15, 15, "*"))
    .appendField(Blockly.Msg.StopPlay);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

// 麦克风
Blockly.Blocks['mic'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/录音.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Microphone);
    this.setOutput(true, "Number");
    this.setColour("#5ca3fb");
    this.setTooltip('');
    this.setHelpUrl('');
}
};

// LED灯控制
Blockly.Blocks['ledcolor'] = {
init: function() {
    this.appendDummyInput()
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldImage("../image/img/灯.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Led)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.Led + "1","LED1"], [Blockly.Msg.Led + "2","LED2"], [Blockly.Msg.Led + "3","LED3"], [Blockly.Msg.Led + "4","LED4"], [Blockly.Msg.All,"ALL"]]), "led")
    .appendField(Blockly.Msg.Color)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.Off,"COLOR0"], [Blockly.Msg.Red,"COLOR1"], [Blockly.Msg.Orange,"COLOR2"], [Blockly.Msg.Yellow,"COLOR3"], [Blockly.Msg.Green,"COLOR4"], [Blockly.Msg.Cyan,"COLOR5"], [Blockly.Msg.Blue,"COLOR6"], [Blockly.Msg.Purple,"COLOR7"]]), "color");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 避障
Blockly.Blocks['tracking'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/避障.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Tracking)
    .appendField(Blockly.Msg.Left)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.OnLine,"NO"], [Blockly.Msg.OutLine,"YES"]]), "left")
    .appendField(Blockly.Msg.Right)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.OnLine,"NO"], [Blockly.Msg.OutLine,"YES"]]), "right");
    this.setOutput(true, "Boolean");
    this.setColour("#5ca3fb");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 录音
Blockly.Blocks['recording'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/录音.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Recording)
    .appendField(new Blockly.FieldTextInput("✎"), "EDIT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 程序入口，开始
Blockly.Blocks['begin'] = {
init: function() {
    this.appendDummyInput()
    .appendField(Blockly.Msg.When)
    .appendField(new Blockly.FieldImage("../icon/running.png", 15, 15, "*"))
    .appendField(Blockly.Msg.OnClick);
    this.setNextStatement(true, null);
    this.setColour("#62d66a");
    this.setTooltip("");
    this.setHelpUrl("");
    this.setDeletable(false);
}
};

// 播放视频
Blockly.Blocks['playmovie'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/播放视频.png", 15, 15, "*"))
    .appendField(Blockly.Msg.PlayMovie)
    .appendField(new Blockly.FieldTextInput("🎬"), "MOVIE");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// if-else
Blockly.Blocks['if_else'] = {
init: function() {
    this.appendValueInput("CONDITION")
    .setCheck("Boolean")
    .setAlign(Blockly.ALIGN_CENTRE)
//    .appendField(new Blockly.FieldImage("https://www.gstatic.com/codesite/ph/images/star_on.gif", 15, 15, "*"))
    .appendField(Blockly.Msg.CONTROLS_IF_MSG_IF);
    this.appendStatementInput("TRUE")
    .setCheck(null)
    .setAlign(Blockly.ALIGN_CENTRE)
    .appendField(Blockly.Msg.CONTROLS_REPEAT_INPUT_DO);
    this.appendStatementInput("FALSE")
    .setCheck(null)
    .setAlign(Blockly.ALIGN_CENTRE)
    .appendField(Blockly.Msg.CONTROLS_IF_MSG_ELSE);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#fbb13b");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// if-elseif-else
Blockly.Blocks['if_elseif_else'] = {
init: function() {
    this.appendValueInput("CONDITION1")
    .setCheck("Boolean")
    .setAlign(Blockly.ALIGN_CENTRE)
//    .appendField(new Blockly.FieldImage("https://www.gstatic.com/codesite/ph/images/star_on.gif", 15, 15, "*"))
    .appendField(Blockly.Msg.CONTROLS_IF_MSG_IF);
    this.appendStatementInput("TRUE1")
    .setCheck(null)
    .setAlign(Blockly.ALIGN_CENTRE)
    .appendField(Blockly.Msg.CONTROLS_REPEAT_INPUT_DO);
    this.appendValueInput("CONDITION2")
    .setCheck("Boolean")
    .setAlign(Blockly.ALIGN_CENTRE)
    .appendField(Blockly.Msg.CONTROLS_IF_MSG_ELSEIF);
    this.appendStatementInput("TRUE2")
    .setCheck(null)
    .setAlign(Blockly.ALIGN_CENTRE)
    .appendField(Blockly.Msg.CONTROLS_REPEAT_INPUT_DO);
    this.appendStatementInput("FALSE")
    .setCheck(null)
    .setAlign(Blockly.ALIGN_CENTRE)
    .appendField(Blockly.Msg.CONTROLS_IF_MSG_ELSE);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#fbb13b");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 文字转语音
Blockly.Blocks['say'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../icon/Sound.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Say)
    .appendField(new Blockly.FieldTextInput(Blockly.Msg.Hello), "TEXT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 7音阶
Blockly.Blocks['gamut'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../icon/Sound.png", 15, 15, "*"))
    .appendField(Blockly.Msg.Gamut)
    .appendField(new Blockly.FieldDropdown([["do","1C"], ["re","2D"], ["mi","3E"], ["fa","4F"], ["sol","5G"], ["la","6A"], ["si","7B"]]), "GAMUT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 距离传感器
Blockly.Blocks['distance_sensor'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/超声波.png", 15, 15, "*"))
    .appendField(Blockly.Msg.DistanceSensor)
    .appendField(new Blockly.FieldDropdown([[Blockly.Msg.Sensor + "1","SENSOR1"], [Blockly.Msg.Sensor + "2","SENSOR2"]]), "index");
    this.setOutput(true, "Number");
    this.setColour("#5ca3fb");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 显示文本
Blockly.Blocks['show_text'] = {
init: function() {
    this.appendValueInput("CONTENT")
    .appendField(new Blockly.FieldImage("../image/img/避障.png", 15, 15, "*"))
    .appendField(Blockly.Msg.ShowText)
    .setCheck(["Number", "String"]);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 文本
Blockly.Blocks['content'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldTextInput(Blockly.Msg.Text), "CONTENT");
    this.setOutput(true, "String");
    this.setColour("#21c0fa");
    this.setTooltip("");
    this.setHelpUrl("");
}
};

// 显示比分
Blockly.Blocks['show_score'] = {
init: function() {
    this.appendDummyInput()
    .appendField(new Blockly.FieldImage("../image/img/避障.png", 15, 15, "*"))
    .appendField(Blockly.Msg.ShowScore);
    this.appendValueInput("NUM1")
    .setCheck("Number");
    this.appendDummyInput()
    .appendField(":");
    this.appendValueInput("NUM2")
    .setCheck("Number");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#21c0fa");
    this.setTooltip("");
    this.setHelpUrl("");
}
};
